/***************************************************************************
 *  Copyright (C) 2011 by Resara LLC                                       *
 *  brendan@resara.com                                                     *
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU Lesser General Public License as         *
 *  published by the Free Software Foundation; either version 2 of the     *
 *  License, or (at your option) any later version.                        *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful, but    *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *  Lesser General Public License for more details.                        *
 *                                                                         *
 *  You should have received a copy of the GNU Lesser General Public       *
 *  License along with this program; if not, write to the                  *
 *  Free Software Foundation, Inc.,                                        *
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *                                                                         *
 ***************************************************************************/
#ifndef RDSDHCPGROUP_H
#define RDSDHCPGROUP_H

#include <RdsDhcpValues>
#include <QxtPimpl>

class RdsDhcpGroupPrivate;

/**
	@author Chris Vickery <chris@resara.com>
*/
class RdsDhcpGroup : public RdsDhcpValues
{
	friend class RdsDhcpValues;
	Q_OBJECT;
	QXT_DECLARE_PRIVATE(RdsDhcpGroup);
	QTRPC_SERVICEPROXY_PIMPL(RdsDhcpGroup);
public:
	RdsDhcpGroup(const RdsDhcpGroup &other);
	~RdsDhcpGroup();
	RdsDhcpGroup& operator=(const RdsDhcpGroup &other);

protected:
	RdsDhcpGroup();
	virtual void setData(void* data);

public slots:
	/**
	 *        Gets the name of the group
	 * @return QString containing the name of the group
	 */
	ReturnValue name() const;
	/**
	 *        Sets the name of the group
	 * @param name the name of the group
	 * @return true
	 */
	ReturnValue setName(const QString &name);
};

#endif
