/***************************************************************************
 *  Copyright (C) 2011 by Resara LLC                                       *
 *  brendan@resara.com                                                     *
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU Lesser General Public License as         *
 *  published by the Free Software Foundation; either version 2 of the     *
 *  License, or (at your option) any later version.                        *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful, but    *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *  Lesser General Public License for more details.                        *
 *                                                                         *
 *  You should have received a copy of the GNU Lesser General Public       *
 *  License along with this program; if not, write to the                  *
 *  Free Software Foundation, Inc.,                                        *
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *                                                                         *
 ***************************************************************************/
#ifndef RDSDHCPHOST_H
#define RDSDHCPHOST_H

#include <RdsDhcpValues>
#include <QxtPimpl>

class RdsDhcpHostPrivate;

/**
	@author Chris Vickery <chris@resara.com>
*/
class RdsDhcpHost : public RdsDhcpValues
{
	friend class RdsDhcpValues;
	Q_OBJECT;
	QXT_DECLARE_PRIVATE(RdsDhcpHost);
	QTRPC_SERVICEPROXY_PIMPL(RdsDhcpHost);
public:
	RdsDhcpHost(const RdsDhcpHost &other);
	~RdsDhcpHost();
	RdsDhcpHost& operator=(const RdsDhcpHost &other);
	/**
	 *        Adds Values to the host
	 * @param map map of keys and values
	 * @return true
	 */
	virtual ReturnValue setValues(const QVariantMap &map);
	/**
	 *        Adds a value to the host
	 * @param key key of the value
	 * @param value the value
	 * @return true
	 */
	virtual ReturnValue setValue(const QString &key, const QString &value);

protected:
	RdsDhcpHost();
	virtual void setData(void* data);

public slots:
	/**
	 *        gets the name of the host
	 * @return QString
	 */
	ReturnValue name() const;
	/**
	 *        Sets the name of the host
	 * @param name the name of the host
	 * @return true
	 */
	ReturnValue setName(const QString &name);
};

#endif
